module mealyr(x, c, r, w);
	input x, r, c;
	output w;
	wire d0, d1, d2, v0, v1, v2;
	wire w1, w2, w3;
	
	//D-flip flops
	dffr state2(d2, r, c, v2);
	dffr state1(d1, r, c, v1);
	dffr state0(d0, r, c, v0);
	
	//d2
	and (d2, x, v1, v0);
	
	//d1
	or (d1, w1, w2, w3);
	and (w1, ~x, v2);
	and (w2, ~x, v1, ~v0);
	and (w3, x, ~v1, v0);
	
	//d0
	assign d0 = ~x;
	
	//out
	and (w, x, v2);
endmodule