module moorer(x, c, r, w);
	input x, r, c;
	output w;
	wire d0, d1, d2, v0, v1, v2;
	wire w1, w2, w3, w4, w5, w6;
	
	//D-flip flops
	dffr state2(d2, r, c, v2);
	dffr state1(d1, r, c, v1);
	dffr state0(d0, r, c, v0);
	
	//d2
	or (d2, w1, w2);
	and (w1, x, v2, ~v0);
	and (w2, x, v1, v0);
	
	//d1
	or (d1, w3, w4, w5);
	and (w3, ~x, v1, ~v0);
	and (w4, ~x, v2, ~v0);
	and (w5, x, ~v2, ~v1, v0);
	
	//d0
	or (d0, w6, ~x);
	and (w6, v2, ~v0);
	
	//out
	and (w, v2, v0);
endmodule